/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */      //标记该文件遵循 Apache 2.0 开源许可
package net.micode.notes.data; //标注该文件所属的软件包

//引入
import android.app.SearchManager;//显示该类需要调用的其他类
import android.content.ContentProvider;//ContentProvider是Android 四大组件之一，用于进程间进行数据交互与共享，即跨进程通信，可以通过ContentProvider把应用中的数据共享给其他应用访问，其他应用可以通过ContentProvider对你应用中的数据进行添删改查。
import android.content.ContentUris;//ContentUris是一个工具类，主要是用来处理使用 "content" 约束的Uri对象
import android.content.ContentValues;//导入contentvalues
import android.content.Intent;//Intent 是 一个用于组件间互相通信的信息对象，常用于启动组件和传递数据
import android.content.UriMatcher;// 类：UriMatcher是Android提供的用来操作Uri的工具类
import android.database.Cursor;//查询数据库所需的游标
import android.database.sqlite.SQLiteDatabase;// 引入SQLite数据库
import android.net.Uri;
import android.text.TextUtils;//文本识别处理工具
import android.util.Log;

import net.micode.notes.R;//访问、删除、插入、更新、扩展Notes的数据库
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
/*
为存储和获取数据提供接口。可以在不同的应用程序之间共享数据
        ContentProvider提供的方法
        query：查询
        insert：插入
        update：更新
        delete：删除
        getType：得到数据类型*/
public class NotesProvider extends ContentProvider {
    private static final UriMatcher mMatcher;//.UriMatcher用于匹配Uri

    private NotesDatabaseHelper mHelper;//数据库辅助类的实例化

    private static final String TAG = "NotesProvider";//TAG用来做输出日志的log函数的第一个实参

    private static final int URI_NOTE            = 1;//.1-6全部是Uri资源的id
    private static final int URI_NOTE_ITEM       = 2;//这是一个注册Uri路径的过程
    private static final int URI_DATA            = 3;
    private static final int URI_DATA_ITEM       = 4;

    private static final int URI_SEARCH          = 5;
    private static final int URI_SEARCH_SUGGEST  = 6;

    static {//我们在使用uriMatcher时，先把需要匹配Uri路径全部给注册上
        mMatcher = new UriMatcher(UriMatcher.NO_MATCH);//创建UriMatcher时，调用UriMatcher(UriMatcher.NO_MATCH)表示不匹配任何路径的返回码
        mMatcher.addURI(Notes.AUTHORITY, "note", URI_NOTE);//把需要匹配Uri路径全部给注册上
        mMatcher.addURI(Notes.AUTHORITY, "note/#", URI_NOTE_ITEM);//.有关note的路径注册
        mMatcher.addURI(Notes.AUTHORITY, "data", URI_DATA);//有关数据的路径注册
        mMatcher.addURI(Notes.AUTHORITY, "data/#", URI_DATA_ITEM);
        mMatcher.addURI(Notes.AUTHORITY, "search", URI_SEARCH);
        mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY, URI_SEARCH_SUGGEST);// SUGGEST_URI_PATH_QUERY 并不属于URI的一部分，而应是用于指向此路径的常量。
        mMatcher.addURI(Notes.AUTHORITY, SearchManager.SUGGEST_URI_PATH_QUERY + "/*", URI_SEARCH_SUGGEST);
    }//注册完需要匹配的Uri后，就可以使用sMatcher.match(uri)方法对输入的Uri进行匹配

    /**
     * x'0A' represents the '\n' character in sqlite. For title and content in the search result,
     * we will trim '\n' and white space in order to show more information.
     *///trim()函数是去掉字符串头尾空格的函数，注意：不去掉字符串里面的空格，而仅仅是头尾空格！
    private static final String NOTES_SEARCH_PROJECTION = NoteColumns.ID + ","//声明 NOTES_SEARCH_PROJECTION
        + NoteColumns.ID + " AS " + SearchManager.SUGGEST_COLUMN_INTENT_EXTRA_DATA + ","//设置表明额外数据、推荐显示的文本、图标、操作、数据
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_1 + ","// SearchManager.SUGGEST_COLUMN_TEXT_1是将该字段作为安卓搜索框中建议显示的文本。如果每个建议想显示两行数据，还有SearchManager.SUGGEST_COLUMN_TEXT_2
        + "TRIM(REPLACE(" + NoteColumns.SNIPPET + ", x'0A','')) AS " + SearchManager.SUGGEST_COLUMN_TEXT_2 + ","//AS语句在这里是：把数据库中NoteColumn.SNIPPET字符串用TRIM函数去掉头部和尾部的空格，然后将处理过后的字符串设置为安卓搜索框中推荐显示的一行字符（column_text_1）,如果想显示第二行搜索框则是（column_text_2）
        + R.drawable.search_result + " AS " + SearchManager.SUGGEST_COLUMN_ICON_1 + ","
        + "'" + Intent.ACTION_VIEW + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_ACTION + ","
        + "'" + Notes.TextNote.CONTENT_TYPE + "' AS " + SearchManager.SUGGEST_COLUMN_INTENT_DATA;

    private static String NOTES_SNIPPET_SEARCH_QUERY = "SELECT " + NOTES_SEARCH_PROJECTION//声明NOTES_SNIPPET_SEARCH_QUERY，便签搜索查询
        + " FROM " + TABLE.NOTE// 在特定表中某一字段检索特定子串
        + " WHERE " + NoteColumns.SNIPPET + " LIKE ?"//数据库中LIKE语句的用法：select * from 表名 where 字段名 like 对应值（子串），它主要是针对字符型字段的，它的作用是在一个字符型字段列中检索包含对应子串的。
    //在这里‘？’就是通配符，对应功能是单字模糊匹配
        + " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER
        + " AND " + NoteColumns.TYPE + "=" + Notes.TYPE_NOTE;

    @Override//重定义的标志
    public boolean onCreate() {
        mHelper = NotesDatabaseHelper.getInstance(getContext());//对mHelper进行实例化
        return true;
    }

    @Override
    public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs,//查询uri在数据库中对应的位置
            String sortOrder) {
        Cursor c = null;//声明游标cursor，待会儿会通过query函数的返回值赋值
        SQLiteDatabase db = mHelper.getReadableDatabase();//获取可读数据库
        String id = null;
        switch (mMatcher.match(uri)) {//匹配查找uri
            case URI_NOTE://对于不同的匹配值，在数据库中查找相应的条目
                c = db.query(TABLE.NOTE, projection, selection, selectionArgs, null, null,
                        sortOrder);
                break;
            case URI_NOTE_ITEM://查询便签条目
                id = uri.getPathSegments().get(1);//获取uri中1号描述符
                c = db.query(TABLE.NOTE, projection, NoteColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs, null, null, sortOrder);
                break;
            case URI_DATA://根据日期进行查询
                c = db.query(TABLE.DATA, projection, selection, selectionArgs, null, null,
                        sortOrder);
                break;
            case URI_DATA_ITEM://查询id对应的具体数据
                id = uri.getPathSegments().get(1);//根据日期条目进行查询
                c = db.query(TABLE.DATA, projection, DataColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs, null, null, sortOrder);
                break;
            case URI_SEARCH://搜索的uri
            case URI_SEARCH_SUGGEST://对于特定Uri的搜索：
                if (sortOrder != null || projection != null) {//不合法的参数异常
                    throw new IllegalArgumentException(// throw用于异常处理
                            "do not specify sortOrder, selection, selectionArgs, or projection" + "with this query");
                }

                String searchString = null;//搜索所得的内容
                if (mMatcher.match(uri) == URI_SEARCH_SUGGEST) {//与搜索相关的ur
                    if (uri.getPathSegments().size() > 1) {//得到string的list
                        searchString = uri.getPathSegments().get(1);//得到第二个参数
                    }
                } else {//语句：利用URI的getQueryParameter方法可以获取字符串参数
                    searchString = uri.getQueryParameter("pattern");
                }

                if (TextUtils.isEmpty(searchString)) {//如果字符串为空，返回null。TextUtils.isEmpty()进行字符串的非null判断
                    return null;//格式化搜索的字符串
                }

                try {//抛出异常
                    searchString = String.format("%%%s%%", searchString);//出错检测，如果正常运行，则根据搜索字符串在数据库中查询，
                    c = db.rawQuery(NOTES_SNIPPET_SEARCH_QUERY,//语句：执行本地SQL语句查询
                            new String[] { searchString });//.如果rawquery语句无法执行，抛出异常
                } catch (IllegalStateException ex) {//如果出错，抛出异常
                    Log.e(TAG, "got exception: " + ex.toString());
                }
                break;
            default:// 如果以上多个case均不命中，则抛出未知uri的异常
                throw new IllegalArgumentException("Unknown URI " + uri);//抛出异常
        }
        if (c != null) {// 若getContentResolver发生变化，就接收通知
            c.setNotificationUri(getContext().getContentResolver(), uri);
        }
        return c;//将地址作为结果返回
    }

    @Override
    public Uri insert(Uri uri, ContentValues values) {//.插入一个uri，uri是一个用于标识某一互联网资源名称的字符串
        SQLiteDatabase db = mHelper.getWritableDatabase();//获得可写的数据库
        long dataId = 0, noteId = 0, insertedId = 0;
        switch (mMatcher.match(uri)) {//数据库的插入，用来存放数据
            case URI_NOTE://.新增一个条目
                insertedId = noteId = db.insert(TABLE.NOTE, null, values);//向note中插入新的条目
                break;
            case URI_DATA://通过Data查找
                if (values.containsKey(DataColumns.NOTE_ID)) {//.检查便签id
                    noteId = values.getAsLong(DataColumns.NOTE_ID);//得到value的值并转换成long类型的
                } else {//错误的数据格式，没有note的id
                    Log.d(TAG, "Wrong data format without note id:" + values.toString());//数据格式错误
                }
                insertedId = dataId = db.insert(TABLE.DATA, null, values);//.插入便签数据
                break;
            default:
                throw new IllegalArgumentException("Unknown URI " + uri);//.抛出异常：未知的URI
        }
        // Notify the note uri
        if (noteId > 0) {//更新内容
            getContext().getContentResolver().notifyChange(/*getContext()是获得一个上下文对象（Context）
                    getContentResolver() 获得ContentResolver对 象
                    notifyChange更新ContextResolver对象里面的内容
                    我们在ContentProvider的insert,update,delete等改变之后调用getContext().getContentResolver().notifyChange(uri, null);这样就通知那些监测databases变化的observer了*/
                    ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId), null);//withAppendedId（Uri contentUri, long id）负责把id和contentUri连接成一个新的Uri
        }

        // Notify the data uri
        if (dataId > 0) {//更新日期
            getContext().getContentResolver().notifyChange(//同上，监听对象变化时，对观察者进行通知
                    ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId), null);//返回插入的uri的路径
        }

        return ContentUris.withAppendedId(uri, insertedId);//最后返回插入uri的路径
    }

    @Override//删除一个uri
    public int delete(Uri uri, String selection, String[] selectionArgs) {
        int count = 0;//Uri代表要操作的数据，Android上可用的每种资源 -包括 图像、视频片段、音频资源等都可以用Uri来表示。
        String id = null;
        SQLiteDatabase db = mHelper.getWritableDatabase();//获得可写的数据库
        boolean deleteData = false;//bool类型的常量，标志是否删除数据
        switch (mMatcher.match(uri)) {//查找匹配的uri
            case URI_NOTE://查找到不同类型的相应的uri后在数据库中删除
                selection = "(" + selection + ") AND " + NoteColumns.ID + ">0 ";//根据uri的类型有不同的selection格式，下同
                count = db.delete(TABLE.NOTE, selection, selectionArgs);// 对该notes的uri进行删除
                break;
            case URI_NOTE_ITEM://通过条目查找得到
                id = uri.getPathSegments().get(1);//取得要删除的Note项目的id
                /**
                 * ID that smaller than 0 is system folder which is not allowed to
                 * trash
                 */
                long noteId = Long.valueOf(id);//Long.valueOf(id)将string类型的字符串变为long类型
                if (noteId <= 0) {//. ID小于0表示是系统文件夹，不能删除
                    break;
                }
                count = db.delete(TABLE.NOTE,//删除项目
                        NoteColumns.ID + "=" + id + parseSelection(selection), selectionArgs);
                break;
            case URI_DATA://通过数据查找到uri
                count = db.delete(TABLE.DATA, selection, selectionArgs);//删除数据
                deleteData = true;
                break;
            case URI_DATA_ITEM://删除uri标识的指定数据
                id = uri.getPathSegments().get(1);//通过数据条目查找到
                count = db.delete(TABLE.DATA,//删除
                        DataColumns.ID + "=" + id + parseSelection(selection), selectionArgs);
                deleteData = true;
                break;
            default://匹配失败，则报错
                throw new IllegalArgumentException("Unknown URI " + uri);//未查找到相应的uri
        }
        if (count > 0) {//以上若进行了一次成功的修改，则count>0
            if (deleteData) {//如果真的删除了数据，则要求监听器对观察者发送通知
                getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);//所有修改要对观察者进行提醒
            }
            getContext().getContentResolver().notifyChange(uri, null);//对所有修改进行通知
        }
        return count;
    }
// 更新一个uri
    @Override
    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
        int count = 0;
        String id = null;
        SQLiteDatabase db = mHelper.getWritableDatabase();//获取可写数据库
        boolean updateData = false;
        switch (mMatcher.match(uri)) {//.根据不同的uri，更新数据库
            case URI_NOTE://如果是便签类型，先升级，然后更新数据库
                increaseNoteVersion(-1, selection, selectionArgs);//这个函数下文有定义，升级note版本
                count = db.update(TABLE.NOTE, values, selection, selectionArgs);//数据更新
                break;
            case URI_NOTE_ITEM://便签条目类型，则先获取对应便签id，然后升级，更新数据库
                id = uri.getPathSegments().get(1);//获取该item的id
                increaseNoteVersion(Long.valueOf(id), selection, selectionArgs);
                count = db.update(TABLE.NOTE, values, NoteColumns.ID + "=" + id//对notes item uri进行更新
                        + parseSelection(selection), selectionArgs);//将字符串解析成规定格式
                break;//增加一个noteVersion
            case URI_DATA:// 多个数据进行了修改
                count = db.update(TABLE.DATA, values, selection, selectionArgs);//对该data的uri进行更新
                updateData = true;
                break;
            case URI_DATA_ITEM://指定数据进行了修改
                id = uri.getPathSegments().get(1);//获取该项目id并将其uri更新
                count = db.update(TABLE.DATA, values, DataColumns.ID + "=" + id
                        + parseSelection(selection), selectionArgs);
                updateData = true;
                break;
            default://.匹配失败，则报错
                throw new IllegalArgumentException("Unknown URI " + uri);//抛出错误：未知uri
        }

        if (count > 0) {//note更新
            if (updateData) {//data更新
                getContext().getContentResolver().notifyChange(Notes.CONTENT_NOTE_URI, null);//如果更新数据，所有修改要对观察者进行提醒
            }
            getContext().getContentResolver().notifyChange(uri, null);
        }
        return count;
    }

    private String parseSelection(String selection) {//将字符串解析成规定格式
        return (!TextUtils.isEmpty(selection) ? " AND (" + selection + ')' : "");//更新便签版本
    }

    private void increaseNoteVersion(long id, String selection, String[] selectionArgs) {//增加NoteVersion
        StringBuilder sql = new StringBuilder(120);//创建Stringbuilder对象
        sql.append("UPDATE ");//在数据库中添加内容
        sql.append(TABLE.NOTE);
        sql.append(" SET ");
        sql.append(NoteColumns.VERSION);
        sql.append("=" + NoteColumns.VERSION + "+1 ");

        if (id > 0 || !TextUtils.isEmpty(selection)) {//操作条件selection不为空或者ID>0，增加WHERE语句
            sql.append(" WHERE ");//sql添加where表明选取的范围
        }
        if (id > 0) {//.id>0:更新ID
            sql.append(NoteColumns.ID + "=" + String.valueOf(id));
        }
        if (!TextUtils.isEmpty(selection)) {//输入的文本非空的条件下输入到数据库中
            String selectString = id > 0 ? parseSelection(selection) : selection;// 根据id，判断selection的格式，
            for (String args : selectionArgs) {
                selectString = selectString.replaceFirst("\\?", args);//用args替换掉？的占位符
            }
            sql.append(selectString);//语句：增加selectString语句
        }

        mHelper.getWritableDatabase().execSQL(sql.toString());//execSQL()方法可以执行insert、delete、update和CREATE TABLE之类有更改行为的SQL语句
    }

    @Override
    public String getType(Uri uri) {//仅仅只是声明gettype，并无其他操作
        // TODO Auto-generated method stub
        return null;//初始化，返回一个空指针
    }

}
